000000 IDENTIFICATION DIVISION.
000000 PROGRAM-ID. IF01.
000000 ENVIRONMENT DIVISION.
000000 INPUT-OUTPUT SECTION.
000000 FILE-CONTROL.
000000 DATA DIVISION.                                                    
000000 FILE SECTION.   
000000 WORKING-STORAGE SECTION.
000000 01  STATUS-AREA.                                        
000000     02 INP-STS  PIC  X(2).                  
000000     02 OUT-STS  PIC  X(4) VALUE ALL "X".                  
000000     02 OUT-STS2  PIC  X(4) VALUE HIGH-VALUES.                  
000000     02 OUT-STS3  PIC  X(4) VALUE LOW-VALUES.                  
000000     02 077OUT-NO PIC 9(4).  
000000     02 SUM01    PIC S9(10).                           
000000     02 SUM02    PIC S9(10).                           
000000 01  WORK.
000000     02 MOJI01 PIC X(08).
000000     02 MOJI02 PIC X(07).
000000     02 RESULT PIC 9(03).
000000     02 A PIC 9(02).
000000     02 B PIC 9(02).
000000     02 C PIC 9(02).
000000     02 D PIC 9(02).
000000     02 X PIC S9(02).
000000     02 Y PIC S9(02).
000000     02 Z PIC S9(02).
000000     02 AA PIC X(10).
000000     02 BB PIC X(08).
000000     02 XX PIC X(02).
000000     02 NENREI PIC 9(3) VALUE 24.    
000000     02 WKEY.
000000       03 WCD01 PIC 9(03).
000000       03 WCD02 PIC 9(05).
000000     02 WSU PIC S9(4)V99.
000000 PROCEDURE DIVISION.
000000     PERFORM START-RTN THRU START-RTN-END. 
000000     PERFORM MAIN-RTN  THRU MAIN-RTN-END.
000000     PERFORM END-RTN   THRU END-RTN-END.
000000     STOP RUN.
000000******************************************************
000000*    START-RTN 
000000******************************************************
000000 START-RTN.
000000     DISPLAY "START IF01" .
000000     MOVE "COBOL" TO MOJI01.
000000     MOVE "C#" TO MOJI02.
000000 START-RTN-END.
000000     EXIT.
000000******************************************************
000000*    MAIN-RTN 
000000******************************************************
000000 MAIN-RTN.
000000     PERFORM 01-IF-RTN THRU 01-IF-RTN-END. 
000000     PERFORM 02-IF-RTN THRU 02-IF-RTN-END. 
000000     PERFORM 03-IF-RTN THRU 03-IF-RTN-END. 
000000     PERFORM 04-IF-RTN THRU 04-IF-RTN-END. 
000000     PERFORM 05-IF-RTN THRU 05-IF-RTN-END. 
000000 MAIN-RTN-END.
000000     EXIT.
000000******************************************************
000000*    END-RTN 
000000******************************************************
000000 END-RTN.
000000     DISPLAY "RESULT=[" RESULT "]". 
000000     DISPLAY "END IF01" .
000000 END-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-IF-RTN df
000000******************************************************
000000 01-IF-RTN.
000000     IF MOJI01 = "COBOL"
000000       THEN 
000000         IF MOJI02 = "C#"
000000           THEN
000000             MOVE 100 TO RESULT ;
000000             DISPLAY "MOJI01,MOJI02=[" MOJI01 "][" MOJI02 "]" ;
000000         ELSE
000000           IF MOJI02 = "VB.NET"
000000             THEN
000000               MOVE 99 TO RESULT ;
000000             DISPLAY "MOJI01,MOJI02=[" MOJI01 "][" MOJI02 "]" ;
000000           ELSE
000000               CONTINUE ;
000000           END-IF
000000         END-IF
000000     ELSE
000000         CONTINUE ;
000000     END-IF.     
000000 01-IF-RTN-END.
000000     EXIT.
000000******************************************************
000000*    02-IF-RTN ̏ȗAƔrZq̏ȗ`
000000******************************************************
000000 02-IF-RTN.
000000     MOVE 20 TO A B C D X Y Z.
000000*    *** 
000000     IF A = B OR C OR D
000000        DISPLAY "ALL EQ!"
000000     ELSE
000000        DISPLAY "NOT EQ!"   
000000     END-IF. 
000000*    *** 
000000     IF A > B OR < C OR D
000000        DISPLAY "OK-01"
000000     ELSE
000000        DISPLAY "NG-01"   
000000     END-IF. 
000000*    *** 
000000     IF (A > B OR < C) AND (X = Y OR Z)
000000        DISPLAY "OK-02"
000000     ELSE
000000        DISPLAY "NG-02"   
000000     END-IF. 
000000*    *** 
000000     IF A NOT = B OR C
000000        DISPLAY "OK-05"
000000     ELSE
000000        DISPLAY "NG-05"   
000000     END-IF. 
000000*    *** 
000000     IF NENREI < 25 OR NENREI > 49 AND
000000        NENREI < 55 OR NENREI = 24 OR
000000        NENREI = 36 OR NENREI = 48
000000          DISPLAY "OK-03"
000000     ELSE
000000          DISPLAY "NG-03"
000000     END-IF. 
000000*    *** 
000000     IF NENREI < 25 OR > 49 AND
000000        LESS 55 OR = 24 OR 36 OR 48
000000          DISPLAY "OK-04"
000000     ELSE
000000          DISPLAY "NG-04"
000000     END-IF. 
000000*    *** 
000000 02-IF-RTN-END.
000000     EXIT.
000000******************************************************
000000*    03-IF-RTN ̔r
000000******************************************************
000000 03-IF-RTN.
000000*    *** 
000000     MOVE "AA" TO AA BB. 
000000     IF AA = BB
000000        DISPLAY "03-IF OK-01"
000000     ELSE
000000        DISPLAY "03-IF NG-01"   
000000     END-IF. 
000000*    *** 
000000     MOVE "1234567890" TO AA BB. 
000000     IF AA > BB OR AA = BB
000000        DISPLAY "03-IF OK-02 [" AA "][" BB "]"
000000     ELSE
000000        DISPLAY "03-IF NG-02 [" AA "][" BB "]"
000000     END-IF. 
000000     MOVE "AA" TO AA MOVE "BB" TO BB. 
000000     IF AA < BB
000000        DISPLAY "03-IF OK-03 [" AA "][" BB "]"
000000     ELSE
000000        DISPLAY "03-IF NG-03 [" AA "][" BB "]"   
000000     END-IF. 
000000 03-IF-RTN-END.
000000     EXIT.
000000******************************************************
000000*    04-IF-RTN Zp
000000******************************************************
000000 04-IF-RTN.
000000     MOVE 10 TO 077OUT-NO A B X Y.
000000     IF 077OUT-NO + A + B > 100 
000000        THEN
000000        COMPUTE SUM01 = 077OUT-NO + A + B
000000        DISPLAY "04-IF-01 OK! [" SUM01 "]" ;
000000     ELSE
000000        COMPUTE SUM01 =  077OUT-NO + A + B
000000        DISPLAY "04-IF-01 NG? [" SUM01 "]" ;
000000        IF A - B * 3 >= B + X * 2 / Y * 3
000000           COMPUTE SUM01 = A - B * 3
000000           COMPUTE SUM02 = B + X * 2 / Y * 3
000000           DISPLAY "04-IF-02 OK! [" SUM01 "][" SUM02 "]" ;
000000        ELSE
000000           COMPUTE SUM01 = A - B * 3
000000           COMPUTE SUM02 = B + X * 2 / Y * 3
000000           DISPLAY "04-IF-02 NG? [" SUM01 "][" SUM02 "]" ;
000000           IF A - (B + 8) * 3 < (B + (X - 5)) / (Y + 4)
000000              COMPUTE SUM01 = A - (B + 8) * 3
000000              COMPUTE SUM02 = (B + (X - 5)) / (Y + 4)
000000              DISPLAY "04-IF-03 OK! [" SUM01 "][" SUM02 "]" ;
000000           ELSE                  
000000              COMPUTE SUM01 = A - (B + 8) * 3
000000              COMPUTE SUM02 = (B + (X - 5)) / (Y + 4)
000000              DISPLAY "04-IF-03 NG! [" SUM01 "][" SUM02 "]" ;
000000           END-IF
000000        END-IF
000000     END-IF.
000000     IF 077OUT-NO + A + B * 8 > 100 OR > 80 OR 70 
000000        COMPUTE SUM01 = 077OUT-NO + A + B * 8
000000        DISPLAY "04-IF-04 OK! [" SUM01 "]" ;
000000     ELSE
000000        COMPUTE SUM01 = 077OUT-NO + A + B * 8
000000        DISPLAY "04-IF-04 NG? [" SUM01 "]" ;
000000     END-IF.
000000 04-IF-RTN-END.
000000     EXIT.
000000******************************************************
000000*    05-IF-RTN \Ӓ萔
000000******************************************************
000000 05-IF-RTN.
000000     MOVE "0123456789" TO AA.
000000     IF AA NUMERIC
000000        DISPLAY "05-IF AA NUMERIC".
000000     IF AA NOT NUMERIC
000000        DISPLAY "05-IF AA NOT NUMERIC".   
000000**
000000     IF AA ALPHABETIC
000000        DISPLAY "05-IF AA ALPHABETIC".
000000     IF AA NOT ALPHABETIC
000000        DISPLAY "05-IF AA NOT ALPHABETIC".   
000000     IF X NUMERIC
000000        DISPLAY "05-IF X NUMERIC " X.
000000     IF X ALPHABETIC
000000        DISPLAY "05-IF X ALPHABETIC".
000000     IF X ZERO
000000        DISPLAY "05-IF X ZERO".
000000**
000000     IF Y = ZERO
000000        DISPLAY "05-IF Y = ZERO".
000000     IF AA = ZERO
000000        DISPLAY "05-IF AA = ZERO".
000000     IF Y NOT = ZERO
000000        DISPLAY "05-IF Y NOT = ZERO".
000000     IF AA NOT = ZERO
000000        DISPLAY "05-IF AA NOT = ZERO".
000000**
000000     IF Y IS ZERO
000000        DISPLAY "05-IF Y IS ZERO".
000000     IF AA ZERO
000000        DISPLAY "05-IF AA ZERO".
000000     IF Y IS NOT ZERO
000000        DISPLAY "05-IF Y IS NOT ZERO".
000000     IF AA NOT ZERO
000000        DISPLAY "05-IF AA NOT ZERO".
000000**
000000     MOVE "mamamama" TO BB.
000000     IF BB = ALL "ma"
000000        DISPLAY "05-IF BB = ALL 'ma'".
000000**
000000     MOVE "zzzzzzzz" TO BB.
000000     IF Z = HIGH-VALUE
000000        DISPLAY "05-IF Z = HIGH-VALUE".
000000     IF BB = HIGH-VALUE
000000        DISPLAY "05-IF BB = HIGH-VALUE " BB.
000000     IF Z NOT = HIGH-VALUE
000000        DISPLAY "05-IF Z NOT = HIGH-VALUE".
000000     IF BB NOT = HIGH-VALUE
000000        DISPLAY "05-IF BB NOT = HIGH-VALUE " BB.
000000**
000000     MOVE -1 TO X. 
000000     IF X IS POSITIVE
000000        DISPLAY "05-IF X IS POSITIVE".
000000     IF X NEGATIVE
000000        DISPLAY "05-IF X NEGATIVE".
000000     IF X IS NOT POSITIVE
000000        DISPLAY "05-IF X IS NOT POSITIVE".
000000     IF X NOT NEGATIVE
000000        DISPLAY "05-IF X NOT NEGATIVE".
000000**
000000     MOVE "00" TO XX. 
000000     IF XX ZERO
000000        DISPLAY "05-IF XX ZERO".
000000     IF XX = ZERO
000000        DISPLAY "05-IF XX = ZERO".
000000     IF XX NOT ZERO
000000        DISPLAY "05-IF XX NOT ZERO".
000000     IF XX NOT = ZERO
000000        DISPLAY "05-IF XX NOT = ZERO".
000000     IF XX IS POSITIVE
000000        DISPLAY "05-IF XX IS POSITIVE".
000000     IF XX NEGATIVE
000000        DISPLAY "05-IF XX NEGATIVE".
000000     IF XX IS NOT POSITIVE
000000        DISPLAY "05-IF XX IS NOT POSITIVE".
000000     IF XX NOT NEGATIVE
000000        DISPLAY "05-IF XX NOT NEGATIVE".
000000**
000000     MOVE ZERO TO WCD01 WCD02. 
000000     IF WKEY = LOW-VALUE
000000        DISPLAY "05-IF WKEY = LOW-VALUE".
000000     IF WKEY NUMERIC
000000        DISPLAY "05-IF WKEY NUMERIC".
000000     IF WKEY ZERO
000000        DISPLAY "05-IF WKEY ZERO".
000000**
000000     MOVE ZERO TO WSU. 
000000     IF WSU ZERO
000000        DISPLAY "05-IF WSU ZERO " WSU.
000000     IF WSU NUMERIC
000000        DISPLAY "05-IF WSU NUMERIC " WSU.
000000     IF WSU POSITIVE
000000        DISPLAY "05-IF WSU POSITIVE".
000000 05-IF-RTN-END.
000000     EXIT.
