000000 IDENTIFICATION DIVISION.
000000 PROGRAM-ID. INDEX02.
000000 ENVIRONMENT DIVISION.
000000 INPUT-OUTPUT SECTION.
000000 FILE-CONTROL.
000000*...t@C
000000       SELECT  IND-FILE   ASSIGN "index.dat"
000000         ORGANIZATION INDEXED
000000           ACCESS DYNAMIC
000000             RECORD KEY JUCD
000000               ALTERNATE RECORD KEY KOUZA
000000                 WITH DUPLICATES
000000               ALTERNATE RECORD KEY NENDO
000000                 WITH DUPLICATES
000000               ALTERNATE RECORD KEY GENGO
000000                 WITH DUPLICATES
000000               FILE   STATUS  IND-FST.                         
000000 DATA DIVISION.                                                    
000000 FILE SECTION.   
000000 FD  IND-FILE                                                             
000000     LABEL RECORD STANDARD.                         
000000 01  IND-REC.                  
000000     02 JUCD PIC 9(5).
000000     02 SIMEI PIC X(10).
000000     02 KOUZA PIC 9(5).
000000     02 NENDO PIC 9(4).  
000000     02 SU PIC S9(3)V99.
000000     02 GENGO PIC X(6). 
000000 WORKING-STORAGE SECTION.
000000 01  STATUS-AREA.                                        
000000     02 IND-FST  PIC  X(2).                  
000000     02 OUT-STS  PIC  X(4) VALUE ALL "X".                  
000000     02 OUT-STS2  PIC  X(4) VALUE HIGH-VALUES.                  
000000     02 OUT-STS3  PIC  X(4) VALUE LOW-VALUES.                  
000000     02 077OUT-NO PIC 9(4).                             
000000     02 WGENGO PIC X(6).
000000     02 WHIKAKU PIC 9(01).
000000     02 WSU    PIC S9(3)V99.
000000     02 WSU2    PIC X(7).
000000     02 WNENDO PIC X(4).
000000     02 WNENDO2 REDEFINES WNENDO PIC 9(4).  
000000     02 WKOUZA PIC X(5).
000000     02 WKOUZA2 REDEFINES WKOUZA PIC 9(5).
000000 01  WORK.
000000     02 INP-CNT PIC 9(3) VALUE ZERO.
000000     02 OUT-CNT PIC 9(3) VALUE 0.
000000     02 UPD-CNT PIC 9(3) VALUE 0.
000000     02 END-SW  PIC 9(1) VALUE ZERO. 
000000 PROCEDURE DIVISION.
000000     PERFORM START-RTN THRU START-RTN-END. 
000000     PERFORM MAIN-RTN  THRU MAIN-RTN-END.
000000     PERFORM END-RTN   THRU END-RTN-END.
000000     STOP RUN.
000000******************************************************
000000*    START-RTN 
000000******************************************************
000000 START-RTN.
000000     DISPLAY "START INDEX02" .
000000 START-RTN-END.
000000     EXIT.
000000******************************************************
000000*    MAIN-RTN 
000000******************************************************
000000 MAIN-RTN.
000000     PERFORM 01-INDEX-RTN THRU 01-INDEX-RTN-END. 
000000     PERFORM 02-INDEX-RTN THRU 02-INDEX-RTN-END. 
000000 MAIN-RTN-END.
000000     EXIT.
000000******************************************************
000000*    END-RTN 
000000******************************************************
000000 END-RTN.
000000     DISPLAY "END INDEX02" .
000000 END-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-INDEX-RTN t@C INPUT,START,READ NEXT 
000000******************************************************
000000 01-INDEX-RTN.
000000*....*** t@CI[v
000000     OPEN INPUT IND-FILE.    
000000*....***
000000 01-INDEX-RTN-A.
000000     DISPLAY "=====(1) input,start,read next =================".
000000     DISPLAY "? c++,c#,php...܂͏I(or 9) " 
000000                                WITH NO ADVANCING.
000000     ACCEPT WGENGO.
000000     IF WGENGO = "9" GO TO 01-INDEX-RTN-E. 
000000     DISPLAY "r? 1.= 2.> 3.>= "WITH NO ADVANCING.
000000     ACCEPT WHIKAKU.
000000     if WHIKAKU = 1 OR 2 OR 3 
000000       THEN CONTINUE 
000000     ELSE 
000000       GO TO 01-INDEX-RTN-A.
000000*    ***
000000     INITIALIZE WORK. 
000000     MOVE WGENGO TO GENGO. 
000000     DISPLAY "START ! (GENGO)=[" GENGO "]".   
000000*    ***
000000     IF WHIKAKU = 1 
000000       START IND-FILE KEY = GENGO INVALID 
000000         DISPLAY "START INV???" GO TO 01-INDEX-RTN-A.
000000     IF WHIKAKU = 2
000000       START IND-FILE KEY > GENGO INVALID 
000000         DISPLAY "START INV???" GO TO 01-INDEX-RTN-A.
000000     IF WHIKAKU = 3
000000       START IND-FILE KEY >= GENGO INVALID 
000000         DISPLAY "START INV???" GO TO 01-INDEX-RTN-A.
000000     PERFORM UNTIL END-SW = 1
000000       READ IND-FILE NEXT            
000000         AT END 
000000           MOVE 1 TO END-SW    
000000         NOT AT END
000000           IF WHIKAKU = 1 AND GENGO NOT = WGENGO
000000             MOVE 1 TO END-SW 
000000             EXIT PERFORM
000000           END-IF  
000000           ADD 1 TO INP-CNT
000000           DISPLAY "-----------------------"
000000           DISPLAY "jucd=" JUCD " kouza=" KOUZA 
000000                   " gengo=[" GENGO "]"
000000           DISPLAY "simei=" SIMEI
000000           DISPLAY "nendo=" NENDO " su=" SU
000000           DISPLAY "IND-REC=" IND-REC
000000       END-READ                                                            
000000     END-PERFORM.
000000*    ***
000000     DISPLAY " input=" INP-CNT.
000000     GO TO 01-INDEX-RTN-A.
000000 01-INDEX-RTN-E.
000000*,,,,*** t@CN[Y
000000     CLOSE IND-FILE.  
000000*,,,,***
000000 01-INDEX-RTN-END.
000000     EXIT.
000000******************************************************
000000*    02-INDEX-RTN t@C I-O REWRITE
000000******************************************************
000000 02-INDEX-RTN.
000000*....*** t@CI[v
000000     OPEN I-O IND-FILE.    
000000*....***
000000 02-INDEX-RTN-A.
000000     DISPLAY "=====(2) I-O,REWRITE ================".
000000     DISPLAY "? c++,c#,php...܂͏I(or 9) " 
000000                                WITH NO ADVANCING.
000000     ACCEPT WGENGO.
000000     IF WGENGO = "9" GO TO 02-INDEX-RTN-E. 
000000     DISPLAY "r? 1.= 2.> 3.>= "WITH NO ADVANCING.
000000     ACCEPT WHIKAKU.
000000     if WHIKAKU = 1 OR 2 OR 3 
000000       THEN CONTINUE 
000000     ELSE 
000000       GO TO 02-INDEX-RTN-A.
000000 02-INDEX-RTN-B.
000000     DISPLAY "Nx? X(4) nendo=" WITH NO ADVANCING.
000000     ACCEPT WNENDO.
000000     IF WNENDO NOT NUMERIC GO TO 02-INDEX-RTN-B.
000000*     IF WNENDO < 1960 GO TO 02-INDEX-RTN-B.
000000     DISPLAY "? 9(5) kouza=" WITH NO ADVANCING.
000000     ACCEPT WKOUZA.
000000     IF WKOUZA NOT NUMERIC GO TO 02-INDEX-RTN-B.
000000*     IF WKOUZA < 11000 GO TO 02-INDEX-RTN-B.
000000*****DISPLAY "? S9(3)V99 su=" WITH NO ADVANCING.
000000*****ACCEPT WSU2.
000000*****IF WSU2 NOT NUMERIC GO TO 02-INDEX-RTN-B.
000000*****MOVE WSU2 TO WSU.
000000*    ***
000000     INITIALIZE WORK. 
000000     MOVE WGENGO TO GENGO. 
000000     DISPLAY "START ! (GENGO)=[" GENGO "]".   
000000*    ***
000000     IF WHIKAKU = 1 
000000       START IND-FILE KEY = GENGO INVALID 
000000         DISPLAY "START INV???" GO TO 02-INDEX-RTN-A.
000000     IF WHIKAKU = 2
000000       START IND-FILE KEY > GENGO INVALID 
000000         DISPLAY "START INV???" GO TO 02-INDEX-RTN-A.
000000     IF WHIKAKU = 3
000000       START IND-FILE KEY >= GENGO INVALID 
000000         DISPLAY "START INV???" GO TO 02-INDEX-RTN-A.
000000     PERFORM UNTIL END-SW = 1
000000       READ IND-FILE NEXT            
000000         AT END 
000000           MOVE 1 TO END-SW    
000000         NOT AT END
000000           IF WHIKAKU = 1 AND GENGO = WGENGO
000000             PERFORM UPD-RTN   THRU UPD-RTN-END
000000*************MOVE 1 TO END-SW EXIT PERFORM
000000           ELSE
000000             IF WHIKAKU = 1 AND GENGO NOT = WGENGO
000000               MOVE 1 TO END-SW EXIT PERFORM
000000             ELSE
000000               ADD 1 TO INP-CNT
000000               DISPLAY "-----------------------"
000000               DISPLAY "jucd=" JUCD " kouza=" KOUZA 
000000                   " gengo=[" GENGO "]"
000000               DISPLAY "simei=" SIMEI
000000               DISPLAY "nendo=" NENDO " su=" SU
000000               DISPLAY "IND-REC=" IND-REC
000000             END-IF
000000           END-IF  
000000       END-READ                                                            
000000     END-PERFORM.
000000*    ***
000000     DISPLAY " input=" INP-CNT.
000000     DISPLAY " UPDATE=" UPD-CNT.
000000     GO TO 02-INDEX-RTN-A.
000000 02-INDEX-RTN-E.
000000*,,,,*** t@CN[Y
000000     CLOSE IND-FILE.  
000000*,,,,***
000000 02-INDEX-RTN-END.
000000     EXIT.
000000******************************************************
000000*    UPD-RTN 
000000******************************************************
000000 UPD-RTN.
000000     MOVE WNENDO2 TO NENDO.
000000     MOVE WKOUZA2 TO KOUZA.
000000     REWRITE IND-REC
000000       INVALID 
000000         DISPLAY "REWRITE INVALID??? STOP"
000000         STOP RUN
000000     END-REWRITE.
000000     ADD 1 TO UPD-CNT.
000000 UPD-RTN-END.
000000     EXIT.
