000000 IDENTIFICATION DIVISION.
000000 PROGRAM-ID. MOVE01.
000000 ENVIRONMENT DIVISION.
000000 INPUT-OUTPUT SECTION.
000000 FILE-CONTROL.
000000 DATA DIVISION.                                                    
000000 FILE SECTION.   
000000 WORKING-STORAGE SECTION.
000000 01  WORK.
000000     02 CNT01 PIC 9(5).
000000     02 CNT02 PIC 9(5).
000000     02 CNT   PIC 9(5) VALUE ZERO.
000000 01  WORK-SU.
000000     02 SU01 PIC 9(2). 
000000     02 SU02 PIC 9(4). 
000000     02 SU03 PIC S9(2)V9. 
000000     02 SU04 PIC S9(4)V99. 
000000     02 SU05 PIC S9(8)V9(4). 
000000     02 SU06 PIC S9(4). 
000000     02 SU07 PIC S9(8). 
000000 01  WORK-MOJI.
000000     02 MJ01 PIC X(1). 
000000     02 MJ02 PIC X(2). 
000000     02 MJ03 PIC X(5). 
000000     02 MJ04 PIC X(10). 
000000 01  WORK2.
000000*    02 AI PIC 9(3).
000000     02 ARY-AA OCCURS 5 INDEXED BY AI PIC 9(04). 
000000 PROCEDURE DIVISION.
000000     PERFORM START-RTN THRU START-RTN-END. 
000000     PERFORM MAIN-RTN  THRU MAIN-RTN-END.
000000     PERFORM END-RTN   THRU END-RTN-END.
000000     STOP RUN.
000000******************************************************
000000*    START-RTN 
000000******************************************************
000000 START-RTN.
000000     DISPLAY "START MOVE01" .
000000 START-RTN-END.
000000     EXIT.
000000******************************************************
000000*    MAIN-RTN 
000000******************************************************
000000 MAIN-RTN.
000000     PERFORM 01-MOVE-RTN     THRU 01-MOVE-RTN-END. 
000000     PERFORM 01-ADD-RTN      THRU 01-ADD-RTN-END. 
000000     PERFORM 01-SUBTRACT-RTN THRU 01-SUBTRACT-RTN-END. 
000000     PERFORM 01-MULTIPLY-RTN THRU 01-MULTIPLY-RTN-END. 
000000     PERFORM 01-DIVIDE-RTN   THRU 01-DIVIDE-RTN-END. 
000000     PERFORM 01-COMPUTE-RTN  THRU 01-COMPUTE-RTN-END. 
000000 MAIN-RTN-END.
000000     EXIT.
000000******************************************************
000000*    END-RTN 
000000******************************************************
000000 END-RTN.
000000     DISPLAY "END MOVE01" .
000000 END-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-MOVE-RTN
000000******************************************************
000000 01-MOVE-RTN.
000000*    ***
000000     INITIALIZE WORK-MOJI.
000000     MOVE "COBOL" TO MJ01 MJ02 MJ03 MJ04.
000000     DISPLAY "WORK-MOJI " WORK-MOJI.
000000     DISPLAY "MJ01-04 " MJ01 " " MJ02 " " MJ03 " " MJ04.
000000*    ***
000000     INITIALIZE WORK-SU.
000000     MOVE -1234.56 TO SU01 SU02 SU03 SU04 SU05 SU06 SU07.
000000     DISPLAY "WORK-SU " WORK-SU.
000000     DISPLAY "SU01-04 " SU01 " " SU02 " " SU03 " " SU04 
000000                             " " SU05 " " SU06 " " SU07.
000000 01-MOVE-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-ADD-RTN
000000******************************************************
000000 01-ADD-RTN.
000000*    ***
000000     MOVE ZERO TO SU06.
000000     ADD +123.5 TO SU06.
000000     DISPLAY "add SU06 " SU06.
000000*    *** ľܓ
000000     MOVE ZERO TO SU06 .
000000     ADD +123.5 TO SU06 ROUNDED.   
000000     DISPLAY "add rounded SU06 " SU06.
000000*    *** ӂ
000000     MOVE ZERO TO SU04 .
000000     ADD -12345.67 TO SU04
000000       ON SIZE ERROR
000000         DISPLAY "add -12345.67 size err! SU04 " SU04
000000       NOT ON SIZE ERROR
000000         DISPLAY "add -12345.67 size ok!  SU04 " SU04
000000     END-ADD.
000000*    *** ӂ
000000     MOVE ZERO TO SU04 .
000000     ADD -1234.56 TO SU04
000000       ON SIZE ERROR
000000         DISPLAY "add -1234.56 size err! SU04 " SU04
000000       NOT ON SIZE ERROR
000000         DISPLAY "add -1234.56 size ok!  SU04 " SU04
000000     END-ADD.
000000*    ***
000000     MOVE 1 TO ARY-AA(1) MOVE 2 TO ARY-AA(2).
000000     MOVE 3 TO ARY-AA(3) MOVE 4 TO ARY-AA(4).
000000     PERFORM VARYING AI FROM 1 BY 1 UNTIL AI > 4
000000     DISPLAY "ARY-AA(" AI ") " ARY-AA(AI)
000000     END-PERFORM.
000000*    *
000000     ADD ARY-AA(1) ARY-AA(2) TO ARY-AA(3) ARY-AA(4).
000000*    *
000000     PERFORM VARYING AI FROM 1 BY 1 UNTIL AI > 4
000000     DISPLAY "add to AA(" AI ") " ARY-AA(AI)
000000     END-PERFORM.
000000*    ***
000000     MOVE 1 TO ARY-AA(1) MOVE 2 TO ARY-AA(2).
000000     MOVE 3 TO ARY-AA(3) MOVE 4 TO ARY-AA(4).
000000     PERFORM VARYING AI FROM 1 BY 1 UNTIL AI > 4
000000     DISPLAY "ARY-AA(" AI ") " ARY-AA(AI)
000000     END-PERFORM.
000000*    *
000000     ADD ARY-AA(1) ARY-AA(2) TO ARY-AA(3) GIVING ARY-AA(4).
000000*    *
000000     PERFORM VARYING AI FROM 1 BY 1 UNTIL AI > 4
000000     DISPLAY "add giv AA(" AI ") " ARY-AA(AI)
000000     END-PERFORM.
000000 01-ADD-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-SUBTRACT-RTN
000000******************************************************
000000 01-SUBTRACT-RTN.
000000*01  WORK-SU.
000000*    02 SU01 PIC 9(2). 
000000*    02 SU02 PIC 9(4). 
000000*    02 SU03 PIC S9(2)V9. 
000000*    02 SU04 PIC S9(4)V99. 
000000*    *
000000     MOVE 2 TO SU01 MOVE 4 TO SU02.
000000     MOVE -88.3 TO SU03. MOVE 100 TO SU04.
000000     DISPLAY "sub SU01-04 " SU01 " " SU02 " " SU03 " " SU04.
000000*    *
000000     SUBTRACT SU01 FROM SU02.  
000000     DISPLAY "sub SU01-04 " SU01 " " SU02 " " SU03 " " SU04.
000000*    *
000000     SUBTRACT SU01 SU02 FROM SU03.  
000000     DISPLAY "sub SU01-04 " SU01 " " SU02 " " SU03 " " SU04.
000000*    *
000000     SUBTRACT SU01 SU02 FROM SU03 GIVING SU04 ROUNDED.  
000000     DISPLAY "sub SU01-04 " SU01 " " SU02 " " SU03 " " SU04.
000000 01-SUBTRACT-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-MULTIPLY-RTN
000000******************************************************
000000 01-MULTIPLY-RTN.
000000*    *
000000     MOVE 5 TO SU01 MOVE 8 TO SU02.
000000     MOVE -77.5 TO SU03. MOVE 100 TO SU04.
000000     DISPLAY "mul SU01-04 " SU01 " " SU02 " " SU03 " " SU04.
000000     MULTIPLY SU04 BY SU01 
000000       ON SIZE ERROR
000000         DISPLAY "mul SU04 by SU01 size err! SU01 " SU01
000000       NOT ON SIZE ERROR
000000         DISPLAY "mul SU04 by SU01 size ok!  SU01 " SU01
000000     END-MULTIPLY.
000000     DISPLAY "mul SU01-04 " SU01 " " SU02 " " SU03 " " SU04.
000000*    *
000000     MULTIPLY SU04 BY SU02 
000000       ON SIZE ERROR
000000         DISPLAY "mul SU04 by SU02 size err! SU02 " SU02
000000       NOT ON SIZE ERROR
000000         DISPLAY "mul SU04 by SU02 size ok!  SU02 " SU02
000000     END-MULTIPLY.
000000     DISPLAY "mul SU01-04 " SU01 " " SU02 " " SU03 " " SU04.
000000*    *
000000     MULTIPLY SU01 BY SU03 GIVING SU07 ROUNDED.  
000000     DISPLAY "mul SU01 by SU03 giving SU07 ROUNDED " SU07.
000000 01-MULTIPLY-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-DIVIDE-RTN
000000******************************************************
000000 01-DIVIDE-RTN.
000000*    *
000000     MOVE 6 TO SU01 MOVE 8 TO SU02.
000000     MOVE -77.5 TO SU03. MOVE 1000 TO SU04.
000000     DISPLAY "div SU01-04 " SU01 " " SU02 " " SU03 " " SU04.
000000     DIVIDE SU01 INTO SU02.
000000     DISPLAY "div SU01 into SU02 SU02=" SU02.
000000*    *
000000     MOVE 8 TO SU02.
000000     DISPLAY "div SU01-04 " SU01 " " SU02 " " SU03 " " SU04.
000000     DIVIDE SU04 BY SU02 GIVING SU01
000000       ON SIZE ERROR
000000         DISPLAY "div SU04 by SU02 size err! SU01 " SU01
000000       NOT ON SIZE ERROR
000000         DISPLAY "div SU04 by SU02 size ok!  SU01 " SU01
000000     END-DIVIDE.
000000     DISPLAY "div SU01-04 " SU01 " " SU02 " " SU03 " " SU04.
000000*    *
000000     DIVIDE SU01 INTO SU04 GIVING SU07 REMAINDER SU06.
000000     DISPLAY "div SU01 into SU04 giving SU07=" SU07
000000                                 " remainder=" SU06.
000000 01-DIVIDE-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-COMPUTE-RTN
000000******************************************************
000000 01-COMPUTE-RTN.
000000*    *
000000     COMPUTE SU04 SU05 = 123.445 * 1.  
000000     DISPLAY "com SU04=" SU04 " SU05=" SU05.
000000*    *
000000     COMPUTE SU04 ROUNDED SU05 ROUNDED = 123.445 * 1.  
000000     DISPLAY "com SU04=" SU04 " SU05=" SU05 " rounded".
000000*    *
000000     COMPUTE SU01 = 99.999
000000       ON SIZE ERROR
000000         DISPLAY "com SU01 = 99.999 size err! SU01 " SU01
000000       NOT ON SIZE ERROR
000000         DISPLAY "com SU01 = 99.999 size ok!  SU01 " SU01
000000     END-COMPUTE.
000000*    *
000000     COMPUTE SU01 = 123.89
000000       ON SIZE ERROR
000000         DISPLAY "com SU01 = 123.89 size err! SU01 " SU01
000000       NOT ON SIZE ERROR
000000         DISPLAY "com SU01 = 123.89 size ok!  SU01 " SU01
000000     END-COMPUTE.
000000 01-COMPUTE-RTN-END.
000000     EXIT.
