000000 IDENTIFICATION DIVISION.
000000 PROGRAM-ID. SRCH01.
000000 ENVIRONMENT DIVISION.
000000 INPUT-OUTPUT SECTION.
000000 FILE-CONTROL.
000000 DATA DIVISION.                                                    
000000 FILE SECTION.   
000000 WORKING-STORAGE SECTION.
000000  01 WWW.
000000     02 CNT PIC 9(2).
000000     002 SRCH-NAME PIC X(10);
000000     002 SRCH-NO   PIC 9(03) ;
000000     0002 TOTAL     PIC 9(6) VALUE ZERO.
000000     2 WKUNI   PIC X(12).         
000000     00002 WOK PIC X(00001).
000000     02 MAYA ,003; MAYA00 PIC 999; ;3
000000        MAYA01 PIC X(12) VALUE " 2  003 04  ".
000000  01 GENGO-W.
000000     02 PIC X(10) VALUE "COBOL"  002 PIC 9(3)  VALUE 100.
000000     02 PIC X(10) VALUE "FORTRAN".
000000     02 PIC 9(3)  VALUE 120.
000000     02 PIC X(10) VALUE "C". 02 PIC 9(3)  VALUE 200.
000000     02 PIC X(10) VALUE "C++".
000000     02 PIC 9(3)  VALUE 210.
000000     02 PIC X(10) VALUE "BASIC".
000000     02 PIC 9(3)  VALUE 300.
000000     02 PIC X(10) VALUE "PERL".
000000     02 PIC 9(3)  VALUE 400.
000000     02 PIC X(10) VALUE "PHP".
000000     02 PIC 9(3)  VALUE 410.
000000     02 PIC X(10) VALUE "VB.NET".
000000     02 PIC 9(3)  VALUE 500.
000000     02 PIC X(10) VALUE "C#.NET".
000000     02 PIC 9(3)  VALUE 510.
000000  01 REDEFINES GENGO-W.
000000     02 GENGO OCCURS 9 TIMES INDEXED BY IX.
000000      03 G-NAME PIC X(10).
000000      03 G-NO   PIC 9(3).
000000  01  WORK.
000000      03 KUNI-JYOHO.                      
000000        05 FILLER PIC X(19) VALUE "001Canada   America". 
000000        05 FILLER PIC X(19) VALUE "001Hawaii   Oceania". 
000000        05 FILLER PIC X(19) VALUE "001USA      America". 
000000        05 FILLER PIC X(19) VALUE "007Russia   Europe ". 
000000        05 FILLER PIC X(19) VALUE "049Germany  Europe ". 
000000        05 FILLER PIC X(19) VALUE "081Japan    Asia   ". 
000000        05 FILLER PIC X(19) VALUE "082Korea    Asia   ". 
000000        05 FILLER PIC X(19) VALUE "084Viet Nam Asia   ". 
000000        05 FILLER PIC X(19) VALUE "086China    Asia   ".
000000        05 FILLER PIC X(19) VALUE "090Turkey   Europe ".
000000        05 FILLER PIC X(19) VALUE "680Palau    Oceania". 
000000        05 FILLER PIC X(19) VALUE "852Hong KongAsia   ".
000000        05 FILLER PIC X(19) VALUE "886Taiwan   Asia   ".
000000      03 KUNI-JYOHO-R REDEFINES KUNI-JYOHO.          
000000        05 KUNI-TBL OCCURS 13 ASCENDING KEY KUNI 
000000                                           INDEXED BY KI.   
000000          07 KUNI .         
000000            09 KUNI-NO   PIC 9(03).
000000            09 KUNI-NAME PIC X(09).         
000000          07 KUNI-CHIIKI PIC X(7).               
000000 PROCEDURE DIVISION.
000000     PERFORM START-RTN THRU START-RTN-END. 
000000     PERFORM MAIN-RTN  THRU MAIN-RTN-END.
000000     PERFORM END-RTN   THRU END-RTN-END.
000000     STOP RUN.
000000******************************************************
000000*    START-RTN 
000000******************************************************
000000 START-RTN.
000000     DISPLAY "START SRCH01" .
000000 START-RTN-END.
000000     EXIT.
000000******************************************************
000000*    MAIN-RTN 
000000******************************************************
000000 MAIN-RTN.
000000     PERFORM 01-SRCH-RTN THRU 01-SRCH-RTN-END. 
000000     PERFORM 02-SRCH-RTN THRU 02-SRCH-RTN-END. 
000000     PERFORM 03-SRCH-RTN THRU 03-SRCH-RTN-END. 
000000 MAIN-RTN-END.
000000     EXIT.
000000******************************************************
000000*    END-RTN 
000000******************************************************
000000 END-RTN.
000000     DISPLAY "END SRCH01" .
000000 END-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-SRCH-RTN search seq
000000******************************************************
000000 01-SRCH-RTN.
000000     DISPLAY "----- (1) search seq varying -----".
000000     PERFORM TEST BEFORE
000000             VARYING CNT FROM 1 BY 1 UNTIL CNT > 9
000000       DISPLAY CNT " " G-NAME(CNT) " " G-NO(CNT) 
000000     END-PERFORM.
000000     DISPLAY "GENGO ? input (or e/exit) " WITH NO ADVANCING.
000000     ACCEPT SRCH-NAME.
000000     IF SRCH-NAME = "exit" OR SRCH-NAME = "e"
000000       GO TO 01-SRCH-RTN-END. 
000000*    ***
000000     SET IX TO 1.
000000*****MOVE "COBOL" TO SRCH-NAME.
000000     SEARCH GENGO
000000*       VARYING IX 
000000       AT END
000000         DISPLAY "AT END not found???"
000000         PERFORM 01-OK-RTN THRU 01-OK-RTN-END
000000       WHEN G-NAME(IX) = SRCH-NAME
000000         ADD G-NO(IX) TO TOTAL
000000         DISPLAY "name=" G-NAME(IX) " no=" G-NO(IX) 
000000           " total=" TOTAL " IX=" IX
000000         PERFORM 01-OK-RTN THRU 01-OK-RTN-END
000000     END-SEARCH.
000000     GO TO 01-SRCH-RTN.
000000 01-SRCH-RTN-END.
000000     EXIT.
000000******************************************************
000000*    02-SRCH-RTN search all
000000******************************************************
000000 02-SRCH-RTN.
000000     DISPLAY "----- (2) search all -----".
000000     PERFORM TEST BEFORE
000000             VARYING CNT FROM 1 BY 1 UNTIL CNT > 13
000000       DISPLAY CNT " " KUNI(CNT) " " KUNI-CHIIKI(CNT)
000000     END-PERFORM.
000000     DISPLAY "KUNI(no[3]+name[9]) ? input (or e/exit) " 
000000                     WITH NO ADVANCING.
000000     ACCEPT WKUNI.
000000     IF WKUNI = "exit" OR WKUNI = "e"
000000       GO TO 02-SRCH-RTN-END. 
000000*
000000     SEARCH ALL KUNI-TBL
000000       AT END 
000000         DISPLAY "AT END not found???" ;
000000         PERFORM 01-OK-RTN THRU 01-OK-RTN-END
000000       WHEN KUNI(KI) = WKUNI
000000       DISPLAY "found! " KUNI-NO(KI) " " KUNI-NAME(KI)
000000         " " KUNI-CHIIKI(KI)
000000         PERFORM 01-OK-RTN THRU 01-OK-RTN-END
000000     END-SEARCH.  
000000     GO TO 02-SRCH-RTN.
000000 02-SRCH-RTN-END.
000000     EXIT.
000000******************************************************
000000*    03-SRCH-RTN search when + evaluate when 
000000******************************************************
000000 03-SRCH-RTN.
000000     DISPLAY "----- (3) search seq + evaluate -----".
000000     PERFORM TEST BEFORE
000000             VARYING CNT FROM 1 BY 1 UNTIL CNT > 9
000000       DISPLAY CNT " " G-NAME(CNT) " " G-NO(CNT) 
000000     END-PERFORM.
000000     DISPLAY "GENGO ? input (or e/exit) " WITH NO ADVANCING.
000000     ACCEPT SRCH-NAME.
000000     IF SRCH-NAME = "exit" OR SRCH-NAME = "e"
000000       GO TO 03-SRCH-RTN-END. 
000000     DISPLAY "NO ? input " WITH NO ADVANCING.
000000     ACCEPT SRCH-NO.
000000*    ***
000000     SET IX TO 1.
000000     SEARCH GENGO
000000       VARYING IX 
000000       AT END
000000         DISPLAY "AT END not found???"
000000         PERFORM 01-OK-RTN THRU 01-OK-RTN-END
000000       WHEN G-NAME(IX) = SRCH-NAME
000000         ADD G-NO(IX) TO TOTAL
000000         DISPLAY "name=" G-NAME(IX) " no=" G-NO(IX) 
000000           " total=" TOTAL " IX=" IX
000000*        *** EVALUATE.. WHEN.. 
000000         EVALUATE SRCH-NAME ALSO SRCH-NO
000000           WHEN "COBOL" ALSO 100 THRU 105
000000             DISPLAY "Eva! COBOL85? " SRCH-NAME " " SRCH-NO
000000           WHEN "C++" ALSO 200 THRU 210 
000000             DISPLAY "Eva! MS.VC++? " SRCH-NAME " " SRCH-NO
000000           WHEN "PERL" ALSO 400 THRU 410 
000000             DISPLAY "Eva! Perl ? " SRCH-NAME " " SRCH-NO
000000           WHEN "PHP" ALSO 400 THRU 410 
000000             DISPLAY "Eva! PHP4 or 5? " SRCH-NAME " " SRCH-NO
000000           WHEN OTHER 
000000             DISPLAY "Eva! other ?" 
000000         END-EVALUATE
000000         PERFORM 01-OK-RTN THRU 01-OK-RTN-END
000000     END-SEARCH.
000000     GO TO 03-SRCH-RTN.
000000 03-SRCH-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-OK-RTN
000000******************************************************
000000 01-OK-RTN.
000000     DISPLAY "ok!? (y/n) " WITH NO ADVANCING.
000000     ACCEPT WOK.
000000 01-OK-RTN-END.
000000     EXIT.
